%%%      PLEASE RUN A SPELL CHECKER BEFORE COMMITTING YOUR CHANGES!
%%%      PLEASE RUN A SPELL CHECKER BEFORE COMMITTING YOUR CHANGES!
%%%      PLEASE RUN A SPELL CHECKER BEFORE COMMITTING YOUR CHANGES!
%%%      PLEASE RUN A SPELL CHECKER BEFORE COMMITTING YOUR CHANGES!
%%%      PLEASE RUN A SPELL CHECKER BEFORE COMMITTING YOUR CHANGES!

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{\label{sec:History-8-4}Stable Release Series 8.4}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

This is a stable release series of HTCondor.
As usual, only bug fixes (and potentially, ports to new platforms)
will be provided in future 8.4.x releases.
New features will be added in the 8.5.x development series.

The details of each version are described below.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{\label{sec:New-8-4-11}Version 8.4.11}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\noindent Release Notes:

\begin{itemize}

\item HTCondor version 8.4.11 released on January 23, 2016.

\end{itemize}


\noindent New Features:

\begin{itemize}

\item None.

\end{itemize}

\noindent Bugs Fixed:

\begin{itemize}

\item Fixed a bug where the effects of a startd cron job would not be used by
the \Condor{startd} when making policy decisions (e.g., evaluating the
\MacroNI{START} expression) until an \MacroNI{UPDATE\_INTERVAL} had passed.  This
was generally only noticeable if you set \MacroNI{STARTD\_CRON\_AUTOPUBLISH}
to a value other than \Expr{NEVER}, which could cause the startd to reject claims
from the negotiator that had been made based on the cron-updated value(s).
\Ticket{6057}

\item Fixed a bug in pslot preemption where it could cause matching jobs to
not start for a long time.
\Ticket{6055}

\item Fixed a bug that caused a job to not be cleaned up when the job
lease expires, if glexec is in use.
\Ticket{6058}

\item Fixed a problem, found while testing on Ubuntu 16, where the negotiator
would crash at the end of the negotiation cycle.
\Ticket{6064}

\item Updated the default configuration in the Debian and Ubuntu packages to
look for the Ganglia shared libraries in the proper place.
\Ticket{5939}

\item Updated the Enterprise Linux 7 RPM to require the proper SELinux
utilities for its post-install script.
\Ticket{6081}

\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{\label{sec:New-8-4-10}Version 8.4.10}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\noindent Release Notes:

\begin{itemize}

\item HTCondor version 8.4.10 released on December 13, 2016.

\end{itemize}


\noindent New Features:

\begin{itemize}

\item None.

\end{itemize}

\noindent Bugs Fixed:

\begin{itemize}

\item Added additional SELinux type enforcement rules on Enterprise Linux 7 for
the \Condor{shared\_port} daemon and Linux tuning script. The RPM post install
script makes the HTCondor SELinux domains permissive.
\Ticket{5449}
\Ticket{5560}
\Ticket{5835}

\item Fixed a performance problem in the \Condor{schedd} when
\MacroNI{RequestCpus} was an expression. Added a new parameter
\MacroNI{SCHEDD\_SLOT\_WEIGHT}, which may be needed
if \MacroNI{SLOT\_WEIGHT} is not the default value of "Cpus", and refers to
expressions in the job ad.
\Ticket{5996}

\item When transferring a job's sandbox, the permissions on sub-directories
are now preserved in the same that they are for regular files.
Previously, the permissions were modified by HTCondor daemon's umask,
and directories transferred from a Windows machine to a UNIX machine had
no permissions enabled.
\Ticket{5948}

\item Fixed bug in the \MacroNI{HOLD\_IF\_CPUS\_EXCEEDED} configuration template metaknob.
\Ticket{5933}

\item Fixed a bug in the \MacroNI{LIMIT\_JOB\_RUNTIMES} configuration template metaknob
so that it works in the face of a non-default MaxJobRuntime.
\Ticket{5961}

\item Fixed a bug that made it so a restart of the \Condor{schedd} was required
in order to change \MacroNI{REMOVE\_SIGNIFICANT\_ATTRIBUTES} to remove an attribute that
the \Condor{schedd}s had already marked as significant.
\Ticket{5983}

\item When creating a Google Compute Engine instance, instruct the server
to delete the auto-created disk image when the instance is removed.
\Ticket{5999}

\item Fixed a bug in our support for Google Compute Engine which would
cause authorization tokens to be renewed five minutes after the deadline
instead of five minutes before.  Naturally, this led to ten minutes of
interrupted service for jobs (or workloads) which lasted longer than the
initial valid duration of the tokens.
\Ticket{6009}

\item Fixed a bug that would cause the \Condor{schedd} to crash when a
condor cron job was scheduled to start during the one hour gap in daylight
savings time when the clocks are moved backwards one hour.
\Ticket{5995}

\item Fixed a bug that would cause a core dump when running the condor\_history
command against a remote schedd.  The results would be returned correctly, but a 
core file would appear in the log directory after the command exited.
\Ticket{5956}

\item In the Python bindings, fixed bugs in the LogReader and EventIterator
classes that could cause invocations of poll() to return prematurely with
no event.
\Ticket{5920}

\item Fixed a bug in \Condor{dagman} that caused a file named
\File{''} (two single quotes) to be created if the
\MacroNI{DAGMAN\_SUPPRESS\_JOB\_LOGS} configuration macro was set
to \Expr{True}.
\Ticket{5941}

\item Fixed a bug that can cause the \Condor{starter} to crash if the
connection to the \Condor{shadow} is lost during file transfer.
\Ticket{5972}

\item Fixed a bug that allowed a user to bypass the \MacroNI{MAX\_JOBS\_PER\_OWNER}
limit by specifying an accounting group or nice\_user in their submit file.
\Ticket{5946}

\item When there are no GPUs on a machine, \Condor{gpu\_discovery} would write
 to stderr in addition to its normal output, this made it hard to use the
 \Opt{-config} option as intended.  \Condor{gpu\_discovery} has been changed so
 that it will never write to stderr when the \Opt{-config} option is specified,
 instead it will write error messages as configuration comments to stdout.
 \Ticket{5989}

\item Removed obsolete ControlGroup option from HTCondor's systemd service
unit configuration file.
\Ticket{5997}

\item Compiled benchmarking programs as a Position Independent Executable.
Position Independent Executables are a requirement for entry into Debian 9.
\Ticket{5994}

\item Fixed a denial of service vulnerability when using the \Condor{credd}
on the Windows platform.
\Ticket{5984}

\item Fixed a bug where the \Opt{-pool} argument would be ignored by
\Condor{ssh\_to\_job} under certain circumstances.
\Ticket{5919}

\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{\label{sec:New-8-4-9}Version 8.4.9}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\noindent Release Notes:

\begin{itemize}

\item HTCondor version 8.4.9 released on September 29, 2016.

\end{itemize}


\noindent New Features:

\begin{itemize}

\item Increased the maximum number of unique attributes that can be 
set by the \Condor{chirp} command \Opt{set\_job\_attr\_delayed} from
50 to 100, and added the configuration knob \MacroNI{CHIRP\_DELAYED\_UPDATE\_MAX\_ATTRS}.
See section~\ref{param:ChirpDelayedUpdateMaxAttrs} for more information.
\Ticket{5891}

\end{itemize}

\noindent Bugs Fixed:

\begin{itemize}

\item Fixed a bug where if the \Condor{startd} crashed while running a
Docker universe job, the job would be left running and not removed when
the \Condor{startd} restarted.  The \Condor{startd} now removes any
orphaned Docker universe jobs on restart.
\Ticket{5858}

\item Fixed a bug that printed spurious locking-related warnings to
the StarterLog when running Docker universe jobs.
\Ticket{5876}

\item The Job Router and HTCondor-C now properly send a RESCHEDULE
command to the \Condor{schedd} after submitting a job.
\Ticket{5903}

\item Fixed bugs in the Job Router that could cause a routed job to be
aborted if the \MacroNI{UPDATE\_JOB\_INFO} hook printed attributes to be set in
the job ad.
\Ticket{5899}

\item The Job Router now uses the correct name for the configuration
parameter for the JOB\_FINALIZE hook.
Previously, the Job Router used the name JOB\_EXIT, counter to what was
documented.
\Ticket{5802}

\item Updated systemd configuration to start HTCondor after NIS has started.
\Ticket{5814}

\item Updated systemd configuration to start HTCondor after local LDAP name
service daemon has started.
\Ticket{5836}

\item Updated systemd configuration to attempt restart of HTCondor daemons
after 1 minute.
\Ticket{5836}

\item In the RPM packages, move the systemd tmpfiles configuration file to
the recommended directory (/usr/lib/tmpfiles.d).
\Ticket{5896}

\item Fixed a bug introduced in 8.4.5 that caused configuration variables starting with
STARTD. or STARTER. to be ignored.
\Ticket{5861}

\item Fixed a typo in the desired value of `rmem\_max' in the Linux kernel
tuning script.  Improved logging of Linux kernel tuning script by including
the name of the file (not) being changed.
\Ticket{5829}

\item Fixed a bug that could cause the \Condor{master} to crash after
restarting the \Condor{shared\_port} daemon.
\Ticket{5801}

\item Fixed a bug that could cause the wrong dynamic slots to be preempted
for a match when \MacroNI{ALLOW\_PSLOT\_PREEMPTION} is set to \Expr{True}.
\Ticket{5748}

\item Fixed a bug in \Prog{cream\_gahp} that caused it to delegate
RFC-format X.509 proxies incorrectly to the CREAM service.
\Ticket{5773}

\item Fixed a bug where the Windows version information was set to
a single value for multiple programs.
This resulted in crash boxes for most of the HTCondor tools being reported
as a crash of \Condor{gpu\_discovery}
\Ticket{5795}

\item Fixed a bug whereby the \Condor{collector} process would exit with
an error several times per hour if the configuration knob \Macro{NO\_DNS}
is set to True.
\Ticket{5762}

\item Fixed monitoring of memory and CPU usage of running jobs on Mac OS X.
This monitoring didn't work for a personal installation of HTCondor.
With Mac OS X 10.11 and above, this monitoring resulted in a flood of
errors messages to the system logs for a root-based installation.
\Ticket{5777}

\item Fixed a bug when attempting to authenticate using multiple
methods wherein if a method failed, the remaining methods were not
always attempted.
\Ticket{5674}

\item Fixed a bug where \Condor{userprio} may fail to display
the correct priority factor value for a user associated
with a group.
\Ticket{5848}

\item Fixed a bug that can cause the \Condor{procd} to crash.
Fixed a bug that prevented other daemons from talking to the
\Condor{procd} when it is restarted after a crash.
\Ticket{5863}

\item If the \Condor{procd} crashes, the \Condor{master} now tries to
restart it several times. Previously only one restart attempt was done.
\Ticket{3655}

\item Fixed a bug that resulted in the \Condor{starter} crashing when
attempting to run a BOINC backfill job.
\Ticket{5862}

\item Fixed a bug in the configuration language where an if defined
test would reject a valid variable name when it had both an underscore and a digit.
\Ticket{5914}

\item Fixed a bug that caused the condor\_ssh\_to\_job command to fail
when using the HTCondor RPM installation.
\Ticket{5591}

\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{\label{sec:New-8-4-8}Version 8.4.8}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\noindent Release Notes:

\begin{itemize}

\item HTCondor version 8.4.8 released on July 5, 2016.

\end{itemize}


\noindent New Features:

\begin{itemize}

\item None.

\end{itemize}

\noindent Bugs Fixed:

\begin{itemize}

\item Fixed a memory leak in the condor\_q client code that impacted
users of the Python API call htcondor.Schedd().query().
\Ticket{5727}

\item Fixed a bug that caused file transfers to fail when using Bosco.
\Ticket{5710}

\item Fixed a bug that could cause the \Condor{schedd} to crash when using
\MacroNI{SCHEDD\_CRON\_JOBLIST}.
\Ticket{5715}

\item The \Condor{schedd} now rejects job submissions when the job owner
doesn't have a user account on the machine.
Previously, the \Condor{schedd} would accept such jobs and then fail
to run them.
\Ticket{5734}

\item Fixed a bug introduced in the 8.4.7 release that resulted in the remote
\Condor{history} command failing unless the \Opt{-limit} argument is used.
\Ticket{5735}

\item Fixed a bug in \Condor{history} that caused it to treat all unrecognized arguments
as user names
\Ticket{5706}

\item The high-availability daemon now properly detects changes to the
\MacroNI{HAD\_LIST} when reconfigured.
\Ticket{5753}

\item The high-availability daemon now properly internalizes the
\MacroNI{HAD\_LIST} when reconfigured.
\Ticket{5754}

\item Fixed a bug that caused the \Condor{master} to stop responding after it
restarted a child daemon when shared port is enabled on Windows. This bug could also
result in a hang on shutdown.
\Ticket{5713}

\item Fixed a bug that could cause \Condor{status} or \Condor{q} to
crash when the \Opt{-xml} option is used.
\Ticket{5718}

\item Fixed a bug introduced in the 8.4.7 release that resulted in a parse error from \Condor{submit}
when \Attr{JobAdInformationAttrs} was set in the configuration variable \Macro{SUBMIT\_ATTRS}.
\Ticket{5720}

\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{\label{sec:New-8-4-7}Version 8.4.7}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\noindent Release Notes:

\begin{itemize}

\item HTCondor version 8.4.7 released on June 6, 2016.

\end{itemize}


\noindent New Features:

\begin{itemize}

\item Docker universe jobs now drop all Linux capabilities by default.
The new knob DOCKER\_DROP\_ALL\_CAPABILITIES, which defaults to true
can be set to false to revert to the old behavior.
\Ticket{5679}

\item Added configuration variable \MacroNI{MAX\_TIME\_SKIP} to control 
	how much system clock skip is allowed before the HTCondor daemons
	restart.  See Section~\ref{param:MaxTimeSkip} for more information.

\item On Linux, HTCondor appropriately tunes kernel parameters
root\_maxkeys and root\_maxbytes to prevent \Condor{master} 
startup failures on older Linux kernels.
\Ticket{5671}

\item The configuration variable \MacroNI{SUBMIT\_ATTRS} now understands the +Attr
syntax that \Condor{submit} uses to inject attributes directly into the job ClassAd.
\Ticket{5694}

\item The \Condor{submit} variable \MacroNI{job\_lease\_duration} can now be an
expression.
\Ticket{5694}

\end{itemize}

\noindent Bugs Fixed:

\begin{itemize}

\item All \$function macro substitutions in in configuration files
will now correctly handle variables with subsystem and localname prefixes
as well as self references.  In particular \verb@VAR = $F(VAR)@ now substitutes
correctly rather than hanging forever.
\Ticket{5565}

\item Fixed a bug in Docker universe where the job would
not run with the correct group id.
\Ticket{5649}

\item Fixed a performance problem in the \Condor{schedd} that could
cause it to become unresponsive for several minutes after the
set of significant attributes for negotiation changes.
\Ticket{5648}

\item Fixed a bug where the python bindings ClassAd parser would fail to detect
whether old or new format ClassAds were present in a stream, even though the
ClassAd format was specified in advance.
\Ticket{5643}

\item Fixed a bug where some floating point values would have an extra
\Expr{.0} appended to the end when printed (e.g. \Expr{2E40.0}).
These values could not be read properly by normal number parsing functions.
\Ticket{5682}

\item When using \MacroNI{GRIDMANAGER\_SELECTION\_EXPR}, grid ads from
different \Condor{gridmanager} instances will no longer overwrite
each other in the \Condor{collector}.
\Ticket{5683}

\item In addition to logging to the file \MacroNI{KERNEL\_TUNING\_LOG},
the default \MacroNI{LINUX\_KERNEL\_TUNING\_SCRIPT} now also logs to
syslog and \File{/etc/systcl.d/99-htcondor.conf}.
\Ticket{5489}

\item Fixed a bug on \Condor{history} that could result in truncation of
the job id field.
\Ticket{5527}

\item On Windows, configuring HTCondor to restrict the range of outbound
port numbers may cause substantial delays when using the command-line
tools.  Since we now know that it's not free to do so, \MacroNI{LOWPORT}
and \MacroNI{HIGHPORT} no longer restrict the port numbers of outbound
connections on Windows.  If you still require this functionality, use
\MacroNI{OUT\_LOWPORT} and \MacroNI{OUT\_HIGHPORT}.
\Ticket{4711}

\item Fixed a bug that would cause \Condor{submit} to create extra, incorrectly named
output and error files when \verb@$$@ substitution is used as part of the filenames.
\Ticket{2720}

\item Fixed a bug that would cause the \Condor{history\_helper} to be invoked using
the wrong name on Windows
\Ticket{5656}

\item Fixed a bug that would sometimes cause configuration variables with a subsystem prefix
to be ignored.
\Ticket{5310}

\item Fixed a bug that could cause HAD to fail if a machine has an IPv6
address.
\Ticket{5659}

\item Fixed a bugs in \Condor{history} when fetching history from a remote \Condor{schedd}. The
bugs caused complete failure when the remote \Condor{schedd} was running Windows, and
would corrupt some string values when the remote \Condor{schedd} was any other operating system.
\Ticket{5701}

\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{\label{sec:New-8-4-6}Version 8.4.6}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\noindent Release Notes:

\begin{itemize}

\item HTCondor version 8.4.6 released on April 21, 2016.

\end{itemize}


\noindent New Features:

\begin{itemize}

\item \Condor{advertise} \Opt{-multiple} now tolerates multiple blank lines in the
input file. It no longer quits parsing on the first first blank line that does not
follow a valid ClassAd.
\Ticket{5147}

\end{itemize}


\noindent Bugs Fixed:

\begin{itemize}

\item Fixed bug where when partitionable slots were
enabled in the \Condor{startd}, a job would be unable
to start running on that machine in some cases.
\Ticket{5626}

\item Fixed a bug that would cause the \Condor{startd}
to crash when \Macro{ALLOW\_PSLOT\_PREEMPTION} was enabled.
\Ticket{5586}

\item Fixed a bug introduced in version 8.3 that
removed the attribute \Macro{REMOTE\_GROUP\_RESOURCES\_IN\_USE}
from the job ad in the negotiator.
\Ticket{5593}

\item Fixed a bug where HTCondor would regard as invalid text representations
of IPv6 addresses which were the longest possible.  This bug typically
manifested as a failure to contact hosts which were advertising IPv6 addresses
of this sort.
\Ticket{5585}

\item Fixed a memory leak in the \Condor{negotiator} when
\Macro{ALLOW\_PSLOT\_PREEMPTION} was enabled.
\Ticket{5571}

\item Fixed a bug where after a \Condor{schedd} restart
the submitter attribute \Macro{WEIGHTED\_JOBS\_RUNNING}
would be incorrectly computed.
\Ticket{5637}

\item Fixed a bug when using \MacroNI{CLAIM\_PARTITIONABLE\_LEFTOVERS}
and flocking.
Machines from a remote pool could be treated as if they were in the local
pool.
As a result, the \Attr{RemotePool} attribute would not be set in the ads
of jobs running on these machines, and the \Attr{FlockedJobs} and
\Attr{RunningJobs} attributes of submitter ads would have incorrect
values.
\Ticket{5577}

\item Fixed a bug that could cause a job's supplemental groups to be set
incorrectly when \MacroNI{SOFT\_UID\_DOMAIN} is set to \Expr{True}.
\Ticket{5603}

\item Fixed a bug that caused supplemental groups to be set incorrectly
when executing file transfer plugins and various hooks.
\Ticket{5600}

\item Fixed a bug that resulted in Windows 10 being reported as
WindowsUnknown in the \Attr{OPSYSNAME} attribute of the \Condor{startd}
ClassAd.
\Ticket{5575}

\item Fixed a typo in the \MacroNI{LIMIT\_JOB\_RUNTIMES} policy metaknob
that prevented the policy from working as intended.
\Ticket{5307}

\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{\label{sec:New-8-4-5}Version 8.4.5}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\noindent Release Notes:

\begin{itemize}

\item HTCondor version 8.4.5 released on March 22, 2016.

\end{itemize}


\noindent New Features:

\begin{itemize}

\item The default for \MacroNI{DAGMAN\_LOG\_ON\_NFS\_IS\_ERROR} has
been changed from \Expr{True} to \Expr{False}.  This is the result
of changes in the 8.3 series that mean that file locking is no
longer required on user logs.
\Ticket{5516}

\end{itemize}

\noindent Bugs Fixed:

\begin{itemize}

\item Fixed a bug where HTCondor would unconditionally retry non-successful
DNS lookups of the local system's hostname; this could cause delays of up
to sixty seconds when using command-line tools on systems whose hostname
was not in DNS.  We no longer retry on errors at all, and only retry
failures which are temporary.
\Ticket{5553}

\item Fixed a bug that would cause \Condor{schedd}s flocking to remote
pools to not send no jobs, or fewer jobs than possible to the
remote pool. This was a result of not correctly setting
the submitter attribute \Macro{WeightedJobsRunning} for
flocked pools.
\Ticket{5539}

\item Accounting group names that contain spaces are now rejected by
\Condor{submit} and ignored by the \Condor{negotiator}.
Previously, submitting a job with an accounting group name that contained
a space would cause the \Condor{negotiator} to fail at startup.
\Ticket{5538}

\item Fixed a bug whereby per-job history files (enabled by
the configuration setting \Macro{PER\_JOB\_HISTORY\_DIR}) may briefly
appear to be empty or incomplete.
\Ticket{5562}

\item Fixed a bug whereby ClassAds written into history files
may contain the same attribute multiple times.
\Ticket{5548}

\item Fixed a bug that caused DAGMan to not work correctly with
some local universe node jobs.  (This bug was introduced in version
8.3.0.)
\Ticket{5299}

\item Fixed a bug that resulted in jobs managed by the \Condor{job\_router}
not reporting memory and disk usage of the job correctly.
\Ticket{5552}

\item Reworked a bug fix from the 8.4.3 release that was designed to allow for
more than 100 dynamic slots to be a bit more generous in allocating Disk to
those slots.
Now, those slots are less prone to fail to match subsequent jobs.
\Ticket{5535}

\item Fixed a bug in the randomization of ports within the LOWPORT to HIGHPORT range
that would sometimes generate ports outside of this range on Windows.
\Ticket{5555}

\item Fixed a bug in \Condor{off} \Opt{-peaceful} that could result in never
sending the "off" command to machines when at least one of the machines could
not be contacted when sending the previous "peaceful" command.
\Ticket{5504}

\item When cgroups are in use, limit the amount of file system cache in the
kernel to prevent the OOM killer from killing jobs that use a large amount of
file system cache.
\Ticket{5500}

\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{\label{sec:New-8-4-4}Version 8.4.4}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\noindent Release Notes:

\begin{itemize}

\item HTCondor version 8.4.4 released on February 4, 2016.

\end{itemize}


\noindent New Features:

\begin{itemize}

\item None.

\end{itemize}

\noindent Bugs Fixed:

\begin{itemize}

\item Fixed a bug that caused the \Condor{collector} to crash if
\MacroNI{CONDOR\_DEVELOPERS\_COLLECTOR} failed to resolve.
\Ticket{5492}

\item Fixed a bug that caused Condor-C jobs to fail when
\Attr{JobLeaseDuration} was set to less than one hour (3600 seconds).
The remote job would be aborted due to the job lease not being renewed.
\Ticket{5446}

\item Fixed a bug that could cause HTCondor to misreport an EC2 job as running
when it had in fact been purged from the service.  Fixed bugs that could
cause a running EC2 job to be misreported as idle.  HTCondor also no longer
sends EC2 services superfluous queries.  (This may increase the latency
of HTCondor job status updates.)
\Ticket{4568}

\item The grid manager now aborts if the GAHP hangs, which we detect by
the absence of a response after \MacroNI{GRIDMANAGER\_GAHP\_RESPONSE\_TIMEOUT}
seconds.  The EC2 GAHP now performs many fewer memory allocations in the
course of normal operations, which improves stability on some systems.
\Ticket{5442}

\item Fixed a bug that caused the \Condor{master} to fail if a shared port
daemon address file written by a version of HTCondor prior to 8.4.0
is present.
\Ticket{5488}

\item Fixed a bug that caused updates to the job attribute
\Attr{TimerRemove} to not be respected while the job was being managed
by the \Condor{shadow}, \Condor{gridmanager}, or the Job Router.
\Ticket{5470}

\item Fixed a bug where the job policy expression of a job could appear
in one of the \Attr{Reason} attributes of another job.
\Ticket{5466}

\item Fixed a bug, that occurred on the Windows platform, that would cause
the \Condor{shadow} to hang while trying to delete old shadow logs when the
value of \Macro{MAX\_NUM\_SHADOW\_LOG} was larger than the default value of 1.
This bug would also sometimes result in the \Condor{schedd} hanging.
\Ticket{5499}

\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{\label{sec:New-8-4-3}Version 8.4.3}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\noindent Release Notes:

\begin{itemize}

\item HTCondor version 8.4.3 released on December 16, 2015.

\end{itemize}


\noindent New Features:

\begin{itemize}

\item None.

\end{itemize}

\noindent Bugs Fixed:

\begin{itemize}

\item Fixed a bug that caused the \Opt{-append} option to be handled too
late to apply to the first Queue statement in a \Condor{submit} file.
\Ticket{5414}

\item Fixed a bug that prevented running more than 100 slots on a single
\Condor{startd} with partitionable slots.
\Ticket{5398}

\item Fixed a bug which caused \SubmitCmdNI{ec2\_iam\_profile\_name}
not to work for Spot instances.
\Ticket{5410}

\item Fixed a bug where the cgroup VM limit would not be set for sizes over
2 Gibibytes.
\Ticket{5434}

\item Fixed bugs that prevented the HTCondor daemons from working promptly at
startup when the \Condor{shared\_port} daemon was in use on Windows platforms.
\Ticket{5283}
\Ticket{5430}
\Ticket{5431}
\Ticket{5432}
\Ticket{5433}

\item Added SELinux type enforcement rules to allow the \Condor{schedd}
to use \Prog{sendmail} on Enterprise Linux 7 platforms.
\Ticket{5418}

\item Fixed a bug where HTCondor service would not start if the
\File{condor\_master.pid} file was empty on Linux platforms.
\Ticket{5427}

\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{\label{sec:New-8-4-2}Version 8.4.2}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\noindent Release Notes:

\begin{itemize}

\item HTCondor version 8.4.2 released on November 17, 2015.

\end{itemize}


\noindent New Features:

\begin{itemize}

\item \Condor{history} no longer reports an error when run on a system that does
not have a history file.
This change was made because the history file is not created until after the
first job runs.
So, users were always seeing an error message on a fresh installation of
HTCondor.
\Ticket{5374}

\end{itemize}

\noindent Bugs Fixed:

\begin{itemize}

\item Fixed a bug introduced in 8.4.1 that could cause the \Condor{schedd}
to exit.
This affected remote submit, HTCondor-CE, and HTCondor-C.
\Ticket{4522}

\item The \MacroNI{TCP\_FORWARDING\_HOST} is now honored by
HTCondor client programs.
\Ticket{5339}

\item Fixed a problem where Standard Universe jobs could not restart
from a checkpoint in the Enterprise Linux 6 RPM distribution.
\Ticket{5382}
\Ticket{5383}

\item Fixed bugs in the function of the DAGMan
\Macro{DAGMAN\_MAX\_JOBS\_IDLE}/\Macro{-maxidle} throttle,
especially for node jobs that create multiple procs.
\Ticket{5333}

\item Fixed a problem where the RPMs would claim to publicly provide
Globus shared libraries that are in a private location.
\Ticket{5349}

\item Added a default \Expr{request\_memory} for \Condor{submit} -interactive
of 512 megabytes.  Formerly, the default was one, which is
insufficient in environments that strictly enforce memory
usage.
\Ticket{5344}

\item Fixed a problem were the \Expr{condor\_classad} RPM would claim to
provide a replacement for the \Expr{classad} RPM in EPEL.
\Ticket{5400}

\item HTCondor now applies the configuration settings
\MacroNI{GRIDMANAGER\_GAHP\_CALL\_TIMEOUT} and
\MacroNI{GRIDMANAGER\_CONNECT\_FAILURE\_RETRY\_COUNT}
when running grid universe jobs for EC2 or Google Compute Engine.
\Ticket{5300}

\item Fixed a crash in the \Condor{schedd} that happened when the
schedd was under load and being shutdown in the fast mode.
\Ticket{5371}

\item Added a timeout to the \Condor{fetchlog} command so that it
will not hang forever waiting for a unresponsive daemon.
\Ticket{5325}

\item Fixed a problem that prevented HTCondor from building on some 64-bit Linux
platforms such as Arm64.
This was reported by Debian maintainers as their Bug 804386.
\Ticket{5380}

\item Fixed a problem where the platform string was incorrect in the RPM
packages.
\Ticket{5384}

\end{itemize}

\noindent Known Issues:

\begin{itemize}

\item The DAGMan workflow log file is not correctly written for local
universe DAG node jobs that have no log file specified in the submit file,
which causes DAGMan to wait forever, thinking the jobs have not completed.
Note that this problem can be worked around by specifying \emph{any}
log file for the job, even \Expr{log = /dev/null}.
(This bug is a regression that was introduced some time since version
8.2.4.)
\Ticket{5299}

\item DAG node retries do not work correctly with DAG node submit files
that create more than one proc in the resulting cluster (such nodes
cause DAGMan to hang if the retry is activated).
We believe that this bug has existed since DAGMan first supported
multi-proc node jobs.
\Ticket{5350}

\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{\label{sec:New-8-4-1}Version 8.4.1}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\noindent Release Notes:

\begin{itemize}

\item HTCondor version 8.4.1 released on October 27, 2015.

\end{itemize}

\noindent Known Issues:
\begin{itemize}
\item Remote submit to an 8.4.1 \Condor{schedd} is broken if file transfer is
used.  This also means HTCondor-CE and HTCondor-C are broken.  This bug will
be fixed in version 8.4.2.
\Ticket{4522}

\item \MacroNI{TCP\_FORWARDING\_HOST} is disregarded by HTCondor clients
starting in version 8.3.6.  This bug will be fixed in version 8.4.2 and 8.5.1.
\Ticket{5339}
\end{itemize}


\noindent New Features:

\begin{itemize}

\item Added support to allow an admin to always volume mount
	certain directories into docker universe containers running
	on a host.
\Ticket{5308}

\item Added four policy metaknobs to simplify configuring a policy
	to either preempt or hold jobs that use more memory
	or CPU cores than provisioned in the slot. See the \MacroNI{POLICY}
	category of metaknobs in section~\ref{usecategory:POLICY} for
	additional information.
\Ticket{5250}

\item Added configuration variables and documentation so that we uniformly prefer
    \Macro{<var>\_ATTRS} over \Macro{<var>\_EXPRS} but support both. This includes
    \Macro{STARTD\_ATTRS}, \Macro{STARTD\_JOB\_ATTRS} and \Macro{SUBMIT\_ATTRS}
    which are often used by HTCondor sites which customize the configuration. These
    configuration variables are now exclusively for use by HTCondor administrators;
    The former default values for these variables have been moved into other configuration
    which is reserved for use by HTCondor developers.  This is done to prevent administrators
    from accidentally removing the necessary defaults.
    A warning about use of \Macro{STARTD\_EXPRS} has been disabled unless
    \Macro{STARTD\_ATTRS} or \Macro{SLOT\_TYPE\_<n>\_STARTD\_ATTRS} is also used, since
    the use all three of these at the same time is not supported.
\Ticket{5326}

\item When \Condor{reconfig} and \Condor{restart} are run as root
    they will check to see if the condor user has read access to all of the
    configuration files before sending the command. This is done to prevent aborting the daemons
    accidentally by sending reconfig after the admin creates a new config file and
    forgets to give the condor user read access to that file.
\Ticket{4506}

\item Added the \Opt{-natural} sort option to \Condor{status} to sort the slots
    in numerical order rather than alphabetical order.
\Ticket{5131}

\end{itemize}

\noindent Bugs Fixed:

\begin{itemize}

\item When cgroups are enabled, and CGROUP\_MEMORY\_POLICY is soft, 
HTCondor now also sets the hard limit to the virtual memory limit
of the job, if there is one.
\Ticket{5280}

\item If cgroups are enabled, and a job goes over the memory limit, the
cgroup OOM killer fires, and the job is put on hold.  HTCondor now
updates the job's memory usage statistics with the most up to date
usage, instead of relying on the previous snapshot.
\Ticket{5341}

\item Fixed a bug where the \Condor{kbdd} could not accurately measure
the keyboard idle time.  This daemon now works correctly on Linux systems
whose X server support the MIT screen saver extension.
\Ticket{5265}

\item Fixed a bug which prevented SOAP submissions.
\Ticket{5260}

\item The parameter \Macro{STARTD\_HISTORY} is now set to record
the job histories per startd, in the log directory of the
execute machine. These can be read with the \Condor{history} command.
Previously the default was not to record these.
\Ticket{5257}

\item The parameter \Macro{SCHEDD\_USE\_SLOT\_WEIGHT} now defaults to
true, so that SLOT\_WEIGHT can be used with hierarchical group quotas
and partitionable slots.
\Ticket{5256}

\item Fixed bug whereby occasionally the command-line tools would
	emit debug messages to stderr with text ``I am: hostname: \ldots''.
\Ticket{5276}

\item Fixed a bug that prevented node retries from working on DAG
nodes that are DAG-level NOOP nodes.  (This bug has existed at least since
the 8.2 series.)
\Ticket{5277}

\item Fixed a problem when the HTCondor executables were not compiled
with \Env{RPATH} enabled on Enterprise Linux 6 platforms. \Env{RPATH} is used
to load Globus and other libraries from the condor-externals RPM.
\Ticket{5294}

\item The job attribute \Attr{JobCurrentStartTransferOutputDate} is now
properly reported in the job ad.
\Ticket{5298}

\item Fixed configuration parameter \MacroNI{NETWORK\_HOSTNAME}, which was
broken starting with version 8.3.2.
\Ticket{5288}

\item Fixed a bug that could cause the Job Router to crash when
invoking a transformation hook.
\Ticket{5224}

\item Fixed several memory leaks in the \Prog{nordugrid\_gahp}.
\Ticket{5322}

\item Improved the \Prog{batch\_gahp} to better handle batch systems
that reuse job IDs.
\Ticket{5062}

\item When the \Prog{batch\_gahp} rejects a request because it is
overloaded, the \Condor{gridmanager} now reduces the rate of requests
and retries the rejected request later.
\Ticket{5253}

item The \Condor{had} and \Condor{replication} daemons now work properly
when Shared Port is enabled. They still require their own dedicated ports.
\Ticket{5301}

\item Fixed a bug that cause \Condor{mips} to report numbers about 40 percent lower than it should
on Linux platforms.
\Ticket{5261}

\item Fixed a bug in \Condor{install} that would cause it to configure HTCondor to advertise the public
IP addresses to the collector even when using localhost or 127.0.0.1 for a personal HTCondor.
\Ticket{5286}

\item Fixed a bug in \Condor{q} that caused slices in the Queue statement to be treated as part of the
arguments filename when the slice was longer than 8 characters.
\Ticket{5273}

\item Added SELinux type enforcement rules to allow the \Condor{schedd} to be
able to access user files in NFS mounted file systems.
\Ticket{5343}
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{\label{sec:New-8-4-0}Version 8.4.0}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\noindent Release Notes:

\begin{itemize}

\item HTCondor version 8.4.0 released on September 14, 2015.

\end{itemize}


\noindent New Features:

\begin{itemize}

\item None.

\end{itemize}

\noindent Bugs Fixed:

\begin{itemize}

\item Fixed a bug introduced in HTCondor version 8.3.7 that caused the
\Condor{shared\_port} daemon to leak file descriptors.
Also made HTCondor work better when some HTCondor daemons
are using shared port, but the \Condor{master} is not.
\Ticket{5259}

\item The \Condor{starter} lowers the OOM (out of memory) score of jobs
so the OOM killer is more likely to chose an HTCondor job rather than
an HTCondor daemon or other user process.
\Ticket{5249}

\item Job submission fails if X.509 certificates are advertised with EC2 
grid universe jobs.
Therefore EC2 grid universe jobs no longer advertise their access keys.
\Ticket{5252}

\end{itemize}

